﻿/*-------------------------------------------------------------------
DiffractWD  Program for basic manipulation with powder patterns.
Copyright (c) 2010, Volodimir Vreshch
All rights reserved.
Email : vreshch@DiffractWD.com

You  should  have  received  a copy of the BSD License along with this
program. If not, see <http://diffractwd.com/license.html>.
---------------------------------------------------------------------*/

using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

namespace Base
{
    abstract class AbstractPadContent: IPadContent
    {
        public abstract Control Control
        {
            get;
        }

        public virtual void RedrawContent()
        {
        }

        public virtual void Dispose()
        {
        }

        public void BringToFront()
        {
            PadDescriptor d = this.PadDescriptor;
            if (d != null) d.BringPadToFront();
        }

        protected virtual PadDescriptor PadDescriptor
        {
            get
            {
                if (Workbench.Instance  == null) return null;
                return Workbench.Instance.GetPad(GetType());
            }
        }

        public bool IsVisible
        {
            get
            {
                Control ctl = this.Control;
                return ctl.Visible && ctl.Width > 0 && ctl.Height > 0;
            }
        }        
    }
}
